/*
 * ARP.h
 *
 * Created: 22.12.2018 16:41:44
 *  Author: Thomas
 */ 


#ifndef ARP_H_
#define ARP_H_



#define ARP_ETHERTYPE		(0x0806)	

#define ARP_FRAME_SIZE		(28)

#define ARP_OPERATION_REQ	(0x0001)	// Operation code indicating an ARP Request
#define ARP_OPERATION_RESP	(0x0002)	// Operation code indicating an ARP Response

#define ARP_HW_ETHERNET		(0x0001)	// ARP Hardware type as defined by IEEE 802.3
#define ARP_IP				(0x0800)	// ARP IP packet type as defined by IEEE 802.3



// ARP Frame
typedef struct {
	uint16_t		HardwareType;
	uint16_t		Protocol;
	uint8_t			MacAddrLen;
	uint8_t			ProtocolLen;
	uint16_t		Operation;
	INET_MAC_Type	SenderMacAddr;
	INET_IP_Type	SenderIpAddr;
	INET_MAC_Type	TargetMacAddr;
	INET_IP_Type	TargetIpAddr;
} ARP_FRAME_Type;


int ArpReadFrame(uint8_t* buffer[], uint16_t* size, ARP_FRAME_Type* arpFrame);


int ArpWriteFrame(uint8_t* buffer[], uint16_t* size, ARP_FRAME_Type* arpFrame);


int ArpSetFrame(	uint16_t		operation,
					INET_MAC_Type*	senderMacAddr,
					INET_IP_Type*	senderIpAddr,
					INET_MAC_Type*	targetMacAddr,
					INET_IP_Type*	targetIpAddr,
					ARP_FRAME_Type*	arpFrame );




#endif /* ARP_H_ */