/*
 * Internet.c
 *
 * Created: 29.12.2018 14:07:42
 *  Author: Thomas
 */ 



#include "Internet.h"



uint16_t InetCalcChecksum(uint8_t* buffer, uint16_t length)
{
	uint32_t checksum = 0;
	
	for (int i = 0; i < (length >> 1); i++)
	{
		checksum += (buffer[(i << 1) + 0] << 8);
		checksum += (buffer[(i << 1) + 1] << 0);
	}
	
	if (length & 0x1)
		checksum += (buffer[length & 0xfffe] << 8);
	
	while (checksum & 0xffff0000)
		checksum = (checksum >> 16) + (checksum & 0xffff);
	
	return ~checksum;
}


