/*
 * UDP.h
 *
 * Created: 30.12.2018 18:03:24
 *  Author: Thomas
 */ 


#ifndef UDP_H_
#define UDP_H_


#include "Internet/Internet.h"
#include "Internet/IP/IPV4.h"


#define UDP_IPTYPE					17	// IP type

#define	UDP_HEADER_SIZE				8	// UDP header size




typedef struct {
	uint8_t*	Buffer;
	uint16_t	Length;
} UDP_PTR_DATA_Type;


// UDP Header 
typedef struct {
	uint16_t	ScrPort;		// Source port
	uint16_t	DestPort;		// Destination port
	uint16_t	TotalLength;	// Total datagram length
	uint16_t	Checksum;		// Checksum
} UDP_HEADER_Type;


typedef struct {
	UDP_HEADER_Type		UdpHeader;
	UDP_PTR_DATA_Type	Data;
} UDP_FRAME_Type;



int UdpReadFrame(uint8_t* buffer[], uint16_t* size, IPV4_HEADER_Type* ipHeader, UDP_FRAME_Type* udpFrame);

int UdpWriteFrame(uint8_t* buffer[], uint16_t* size, IPV4_HEADER_Type* ipHeader, UDP_FRAME_Type* udpFrame);

int UdpSetFrame(uint16_t scrPort, uint16_t destPort, UDP_PTR_DATA_Type* data, UDP_FRAME_Type* udpFrame);




#endif /* UDP_H_ */