/*
 * Time.h
 *
 * Created: 18.11.2018 11:25:06
 *  Author: Thomas
 */ 


#ifndef TIME_H_
#define TIME_H_

#include <stdbool.h>
#include "sam.h"

#define TIME_BASE (120000000)


void TimeInit(void);


void Delay_us(uint32_t delay);

void Delay_ms(uint32_t delay);

uint32_t Stopwatch(uint32_t* lastCount);

uint32_t Stopwatch_us(uint32_t* lastCount);

uint32_t Stopwatch_ms(uint32_t* lastCount);

uint32_t IntervalTimer_ms(uint32_t* lastCount, uint32_t ms);



// Timer 
typedef struct {
	uint32_t LastCount;
	uint32_t TimeTicks;
} Timer_Type;

void TimerStart_us(uint32_t time_us, Timer_Type* timer);

void TimerStart_ms(uint32_t time_ms, Timer_Type* timer);

_Bool TimerTest(Timer_Type* timer);



#endif /* TIME_H_ */