/*
 * W5500.h
 *
 * Created: 05.11.2018 18:12:40
 *  Author: Thomas
 */ 


#ifndef W5500_H_
#define W5500_H_


#include <stdbool.h>
#include "sam.h"
#include "W5500CRB.h"
#include "W5500SRB.h"



#define WNET_NOERR				  (0)
#define WNET_ERROR_GENERAL		 (-1)
#define WNET_ERROR_PARAMETER1	 (-2)
#define WNET_ERROR_PARAMETER2	 (-3)
#define WNET_ERROR_PARAMETER3	 (-4)
#define WNET_ERROR_PARAMETER4	 (-5)
#define WNET_ERROR_PARAMETER5	 (-6)
#define WNET_ERROR_PARAMETER6	 (-7)
#define WNET_ERROR_PARAMETER7	 (-8)
#define WNET_ERROR_PARAMETER8	 (-9)
#define WNET_ERROR_PARAMETER9	(-10)
#define WNET_ERROR_RW_ACTIVE	(-11)
#define WNET_ERROR_ASYNC_TERR	(-12)
#define WNET_ERROR_NO_INIT		(-13)



typedef struct {
	uint8_t Ch0RxBufferSize;	uint8_t Ch0TxBufferSize;
	uint8_t Ch1RxBufferSize;	uint8_t Ch1TxBufferSize;
	uint8_t Ch2RxBufferSize;	uint8_t Ch2TxBufferSize;
	uint8_t Ch3RxBufferSize;	uint8_t Ch3TxBufferSize;
	uint8_t Ch4RxBufferSize;	uint8_t Ch4TxBufferSize;
	uint8_t Ch5RxBufferSize;	uint8_t Ch5TxBufferSize;
	uint8_t Ch6RxBufferSize;	uint8_t Ch6TxBufferSize;
	uint8_t Ch7RxBufferSize;	uint8_t Ch7TxBufferSize;
} WNET_SOCKET_INIT_Type;


typedef struct {
	_Bool		IsBusy;
	_Bool		IsCompleted;
	int			AsyncState;
} WNET_RW_ASYNC_RESULT_Type;


typedef void (*WnetRwAsyncCallBack_Type)(void);


int WNetInit(void);

int WNetSocketInit(WNET_SOCKET_INIT_Type* socketInit);


WNET_RW_ASYNC_RESULT_Type WNetGetAsyncResult(_Bool peek);

void WNetEnterCriticalSectionAsyncResult(uint32_t* cs);
void WNetLeaveCriticalSectionAsyncResult(uint32_t* cs);



int WNetWriteByte(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint8_t value);

int WNetWriteHWord(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint16_t value);

int WNetWriteWord(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint32_t value);

int WNetWriteBytes(uint16_t wNetAddress, uint8_t controlPhaseBsel, void* data, uint16_t size);

int WNetBeginWriteBytes(uint16_t wNetAddress, uint8_t controlPhaseBsel, void* data, uint16_t size, WnetRwAsyncCallBack_Type callBack);


int WNetReadByte(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint8_t* value);

int WNetReadHWord(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint16_t* value);

int WNetReadWord(uint16_t wNetAddress, uint8_t controlPhaseBsel, uint32_t* value);

int WNetReadBytes(uint16_t wNetAddress, uint8_t controlPhaseBsel, void* data, uint16_t size);

int WNetBeginReadBytes(uint16_t wNetAddress, uint8_t controlPhaseBsel, void* data, uint16_t size, WnetRwAsyncCallBack_Type callBack);


int WNetWriteIpType(uint16_t wNetAddress, uint8_t controlPhaseBsel, WNET_IP_Type* ip);
int WNetWriteMacType(uint16_t wNetAddress, uint8_t controlPhaseBsel, WNET_MAC_Type* mac);

int WNetReadIpType(uint16_t wNetAddress, uint8_t controlPhaseBsel, WNET_IP_Type* ip);
int WNetReadMacType(uint16_t wNetAddress, uint8_t controlPhaseBsel, WNET_MAC_Type* mac);


int WNetGetStatus(WNET_CRB_PHYCFGR_Type* status);





#endif /* W5500_H_ */